/*	$Id: electricity.c,v 1.8 2001/04/26 03:23:19 pvalchev Exp $	*/

/*
 * Copyright (c) 1998-2001 Peter V. Valchev <pvalchev@gmx.net>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *    
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * 3. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission
 *    from the author.
 * 
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
 * THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
 * ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#define _PHYZ_ELECTICITY_C

#include "phyz.h"
#include "keys.h"
#include "choice.h"

#ifndef lint
static const char rcsid[] = "$Id: electricity.c,v 1.8 2001/04/26 03:23:19 pvalchev Exp $";
#endif /* lint */

void fe_shmek(), ek_shmek(), ef_shmek(), ep_shmek(), ve_shmek(), vi_shmek(), piv_shmek(), iqt_shmek(), rsum_shmek(), rinv_shmek();
void pick_function_list_e ();
void function_list_e ();

int old_shmek = -1;
int new_shmek = 0;

char fshmek;

CHOICE flist_electricity[] =
{
	{ "Fe = (kq,q)/R", fe_shmek },
	{ "|E| = kq/R", ek_shmek },
	{ "E = Fe/q", ef_shmek },
	{ "|E| = V/d (|| plates)", ep_shmek },
	{ "V = E/q", ve_shmek },
	{ "V = IR", vi_shmek },
	{ "P = IV", piv_shmek },
	{ "I = q/t", iqt_shmek },
	{ "R = R1 + R2 + R3", rsum_shmek },
	{ "1/R = 1/R1 + 1/R2 + 1/R3", rinv_shmek }
};

extern void
electricity (WINDOW *win) {
	char buf[80];
	char sf;
	float P, F = 0, d, q, q1, q2, E, V, R, I, R1, R2, R3, num, t;
	float K = 8.99e9;
	pick_choice(old_choice, new_choice);
	while ( dilemma != '3' && dilemma != '4' ) {
		choice_switch();
	}
	win = newwin(LINES, 0, 0, 0);

	/* Theory */
    if ( dilemma == '3' ) {
	waddstr(win, "\t\nHISTORICAL BACKGROUND\n
1) AMBER - semi-transparent solid (yellow or brown) that formed from the sap oozed from softwood trees. In 600 B.C., Thales recognized that it had a property of attraction if rubbed vigorously against a cloth. This is the first evidence of electrostatic attraction.

2) LODESTONE
Lodestone is a mineral (we call magnetite) that has a chemical formula of Fe3O4.\nIt has the unusual property of attracting iron. When suspended or floated in a liquid it will always turn to one particular (North-South) direction. It was used as a compass by the Vikings. This is the first evidence of magnetic attraction.

3) Effluvium Theory - Lucretius was the first scientists to attempt an explanation of the attractive propreties of both amber and lodestone. He suggested that the amber and lodestone had an efflux (or flowing out) of minute particles that would capture other small objects on their way back to the lodestone or amber. Lucretius did not attempt to distinguish between the type of attraction or take account that amber and lodestone did not attract the same materials.
	");

	Continue(win);
	werase(win);
	wrefresh(win);
	wprintw(win, "\t\n4) de MAGNETE\n
Sir William Gilbert (1544-1603) was the chief physician to Queen Elizabeth I of England. He was also a scientists and since Queen Elizabeth was Very healthy, he had lots of time to work on his scientific ideas. He published his work in a document called 'de Magnete' in 1600.
\nIn de Magnete, Gilbert advanced the idea that the Earth had a magnetic field. He reasoned that if small pieces of lodestone always line up the same way on a larger piece of lodestone and also align themselves in one direction with respect to the Earth, then the Earth must be a GIANT LODESTONE.
\nIn de Magnete, Gilbert also attempted to draw a distinction between the properties of lodestone and amber (or in other words, a distinction between Electrostatic and magnetic attraction). Gilbert introduced the term 'electric' to describe bodies that attract the way amber does. (electric comes from Electron, which was the Greek word for amber). Gilbert categorized the properties as Electric (like amber) and Lodestone (magnetic).
	");

	Continue(win);
	werase(win);
	wrefresh(win);
	waddstr(win, "
	- LAW OF MAGNETS: Like poles repel and unlike poles attract.
	- MAGNETIC FIELDS: The magnetic field is the region around a magnet where its influence can be detected by another Magnet. The direction of a magnetic field is the direction in which the N pole of a compass would point if placed in the field.
	- MAGNETIC FLUX: The magnetic field is mapped or represented by a magnetic lines of force called webbers (Wbs) also called magnetic flux lines. These lines are imaginary. Magnetic flux lines run from the N pole of the magnet towards the S pole. The stronger the magnet, the greated the number of flux lines. Magnetic flux has a symbol  and it represents the strenght of a magnet.
	- MAGNETIC FLUX DENSITY: B = /area,  where B = magnetic flux density in TESLA
	                                       = magnetic flux in WEBBERS
	- RULES FOR MAGNETIC LINES OF FORCE:
	i) they never cross each other
	ii) outside of the magnet, their direction is from the N pole to the S pole
	iii) they crowd at the poles
	iv) the greater the strenght of the field, the greated the crowding of the lines
	");
	Continue(win);
	werase(win);
	wrefresh(win);
	wprintw(win, "
	ELECTROSTATICS:
- Early history - Thales discovered that if substances like amber are rubbed with a piece of cloth, they can pick up little shreds of cloth or other small pieces of matter. Gilbert showed that many substances can be electrified by rubbing and as a result they can attract small bits of matter. 
- Law of charges - Like charges repel and unlike charges attract. When a rubber rod is rubbed with fur, the rubber rod receives a negative charge and the fur receives a positive charge. eWhen a glass is rubbed with silk, the glass rod becomes positive and the silk becomes negative. The glass rod and the rubber rod have different charges and are attracted to each other.
- Measuring charge:
	The unit for charge is the COULOMB and the symbol is C.
	A coulomb (C) of positive charge is equal to the combined charge of 6.25e18 protons.. Since a proton cancels an electron, a coulomb of negative charge is equal to the combined charge of 6.25e18 electrons. 
	The charge of a single electron is -1.6e-19 C, and the charge of a single proton is +1.6e-19 C.
	");
	Continue(win);
	werase(win);
	wrefresh(win);
	wprintw(win, "
	COULOMB'S LAW
Charles Coulomb was very intrigued by the intuitive connetion between electrostatic forces and gravitational forces. He immediately began to test the relationship using a TORSION balance. When he combined the two relationships from his experiment together he found that the electrostatic force varied directly as the product of the two charges and inversely as the square of the distance between the two charged objects. Later he was able to replace the proportionally sign with K, which is known as Coulomb's CONSTANT, and has a value of 8.99e9 Nm/C.
	The final result is known as COULOMB'S LAW of electrostatic attraction:

	Fe = Kq(1)q(2)/R
	Note: The minus sign for a final answer indicates an attractive force and a positive answer would indicate a repulsive force. Also note that the size of electrostatic forces is very large when compared to gravitational forces.
	[ ... ]
	");
	Continue(win);
	} 

	/* Solver */
    if ( dilemma == '4' ) { 
	werase(win);
	wrefresh(win);
	*buf = 0;
	num = 0;
	/* XXX: new menu */
	pick_function_list_e(old_choice, new_choice);
	/* listen until : */
	while ( fshmek != '1' && fshmek != '2' && fshmek != '3' && fshmek != '4' && fshmek != '5' && fshmek != '6' && fshmek != '7' && fshmek != '8' && fshmek != '9' && fshmek != '0' ) {
		function_list_e();
	}
	echo();
	if ( fshmek == '1' ) {
		werase(win);
		wrefresh(win);
		waddstr(win, "\nF = (Kq1q2)/R");
		waddstr(win, "\nSolve for (enter the letter)?: ");
		wscanw(win, "%s", &sf, buf);
			if ( !strncmp(&sf, "F", sizeof(char)) ) {
				SOLVE_FOR;
				wprintw(win, "Distance? R = ");
				SW; R = num; num = 0;
				wprintw(win, "R = %f", R);
				wprintw(win, "\nCharge 1? q1 = ");
				SW; q1 = num; num = 0;
				wprintw(win, "q1 = %f", q1);
				wprintw(win, "\nCharge 2? q2 = ");
				SW; q2 = num; num = 0;
				wprintw(win, "\nq2 = %f", q2);
				num = (K*q1*q2)/(R*R);
				wprintw(win, "\nElectric Force = F = %f", num);
			} else if ( !strncmp(&sf, "q1", sizeof(char)) || !strncmp(&sf, "q2", sizeof(char)) ) {
				SOLVE_FOR;
				wprintw(win, "E Force? F = ");
				SW; F = num; num = 0;
				wprintw(win, "F = %f", F);
				wprintw(win, "\nKnown charge? q = ");
				SW; q = num; num = 0;
				wprintw(win, "q = %f", q);
				wprintw(win, "\nDistance? R = ");
				SW; R = num; num = 0;
				wprintw(win, "\nR = %f", R);
				num = (F*R*R)/(K*q);
				wprintw(win, "\nUnknown charge = q = %f", num);
			} else if ( !strncmp(&sf, "R", sizeof(char)) ) {
				SOLVE_FOR;
				wprintw(win, "E Force? F = ");
				SW; F = num; num = 0;
				wprintw(win, "F = %f", F);
				wprintw(win, "\nCharge 1? q1 = ");
				SW; q1 = num; num = 0;
				wprintw(win, "q1 = %f", q1);
				wprintw(win, "\nCharge 2? q2 = ");
				SW; q2 = num; num = 0;
				wprintw(win, "\nq2 = %f", q2);
				num = sqrt((K*q1*q2)/F);
				wprintw(win, "\nDistance = R = %f", num);
			} else if ( !strncmp(&sf, "K", sizeof(char)) ) {
				wprintw(win, "\nYou're asking me to do the impossible.");
				wprintw(win, "\nK is a constant. Sorry.");
			} else {
				NOPE;
			}
		Continue(win);
	} else if ( fshmek == '2' ) {
		werase(win);
		wrefresh(win);
		waddstr(win, "\n|E| = kq/R");
		waddstr(win, "\nSolve for (enter the letter)?: ");
		wscanw(win, "%s", &sf, buf);
			if ( !strncmp(&sf, "E", sizeof(char)) ) {
				SOLVE_FOR;
				wprintw(win, "Charge? q = ");
				SW; q = num; num = 0;
				wprintw(win, "q = %f", q);
				wprintw(win, "\nDistance? R = ");
				SW; R = num; num = 0;
				wprintw(win, "R = %f", R);
				num = fabs((K*q)/(R*R));
				wprintw(win, "\nElectric field strenght = E = %f", num);
			} else if ( !strncmp(&sf, "q", sizeof(char)) ) {
				SOLVE_FOR;
				wprintw(win, "Electric field strenght? E = ");
				SW; E = num; num = 0;
				wprintw(win, "E = %f", E);
				wprintw(win, "\nDistance? R = ");
				SW; R = num; num = 0;
				wprintw(win, "R = %f", R);
				num = (E*R*R)/K;
				wprintw(win, "\nCharge = q = %f", num);
			} else if ( !strncmp(&sf, "R", sizeof(char)) ) {
				SOLVE_FOR;
				wprintw(win, "Electric field strenght? E = ");
				SW; E = num; num = 0;
				wprintw(win, "E = %f", E);
				wprintw(win, "\nCharge? q = ");
				SW; q = num; num = 0;
				wprintw(win, "q = %f", q);
				num = sqrt((K*q)/E);
				wprintw(win, "\nDistance = R = %f", num);
			} else {
				NOPE;
			}
		Continue(win);	
	} else if ( fshmek == '3' ) {
		werase(win); 
		wrefresh(win);
		waddstr(win, "\nE = F/q");
		waddstr(win, "\nSolve for (enter the letter)?: ");
		wscanw(win, "%s", &sf, buf);
		if ( !strncmp(&sf, "E", sizeof(char)) ) {
			SOLVE_FOR;
			wprintw(win, "Electric Force = F = ");
			SW; F = num; num = 0;
			wprintw(win, "F = %f", F);
			wprintw(win, "\nCharge? q = ");
			SW; q = num; num = 0;
			wprintw(win, "q = %f", q);
			num = F/q;
			wprintw(win, "\nE. field strenght = %f", num);
		} else if ( !strncmp(&sf, "F", sizeof(char)) ) {
			SOLVE_FOR;
			wprintw(win, "Electric field strenght? E = ");
			SW; E = num; num = 0;
			wprintw(win, "E = %f", E);
			wprintw(win, "\nCharge? q = ");
			SW; q = num; num = 0;
			wprintw(win, "q = %f", q);
			num = E*q;
			wprintw(win, "\nElectric Force = %f", num);
		} else if ( !strncmp(&sf, "q", sizeof(char)) ) {
			SOLVE_FOR;
			wprintw(win, "Electric field strenght? E = ");
			SW; E = num; num = 0;
			wprintw(win, "E = %f", E);
			wprintw(win, "\nCharge? q = ");
			SW; q = num; num = 0;
			wprintw(win, "q = %f", q);
			num = F/E;
			wprintw(win, "\nCharge = q = %f", num);
		} else {
			NOPE;
		}
	Continue(win);
	} else if ( fshmek == '4' ) {
		werase(win); 
		wrefresh(win);
		waddstr(win, "\nE = V/d");
		waddstr(win, "\nSolve for (enter the letter)?: ");
		wscanw(win, "%s", &sf, buf);
		if ( !strncmp(&sf, "E", sizeof(char)) ) {
			SOLVE_FOR;
			wprintw(win, "Voltage (potential difference b/w plates)? V = ");
			SW; V = num; num = 0;
			wprintw(win, "V = %f", V);
			wprintw(win, "\nDistance between plates? d = ");
			SW; d = num; num = 0;
			wprintw(win, "d = %f", d);
			num = fabs(V/d);
			wprintw(win, "\nElectric field strenght = %f", num);
		} else if ( !strncmp(&sf, "V", sizeof(char)) ) {
			SOLVE_FOR;
			wprintw(win, "Electric field strenght? E = ");
			SW; E = num; num = 0;
			wprintw(win, "E = %f", E);
			wprintw(win, "\nDistance b/w plates? d = ");
			SW; d = num; num = 0;
			wprintw(win, "d = %f", d);
			num = E*d;
			wprintw(win, "\nVoltage = V = %f", num);
		} else if ( !strncmp(&sf, "d", sizeof(char)) ) {
			SOLVE_FOR;
			wprintw(win, "Voltage? V = ");
			SW; V = num; num = 0;
			wprintw(win, "V = %f", V);
			wprintw(win, "\nElectric field strenght? E = ");
			SW; E = num; num = 0;
			wprintw(win, "E = %f", E);
			num = V/E;
			wprintw(win, "\nDistance b/w plates = d = %f", num);
		} else {
			NOPE;
		}
		Continue(win);
	} else if ( fshmek == '5' ) {
		werase(win); 
		wrefresh(win);
		waddstr(win, "\nV = E/q");
		waddstr(win, "\nSolve for (enter the letter)?: ");
		wscanw(win, "%s", &sf, buf);
		if ( !strncmp(&sf, "V", sizeof(char)) ) {
			SOLVE_FOR;
			wprintw(win, "Electric field strenght? E = ");
			SW; E = num; num = 0;
			wprintw(win, "E = %f", E);
			wprintw(win, "\nCharge? q = ");
			SW; q = num; num = 0;
			wprintw(win, "q = %f", q);
			num = E/q;
			wprintw(win, "\nVoltage = V = %f", num);
		} else if ( !strncmp(&sf, "E", sizeof(char)) ) {
			SOLVE_FOR;
			wprintw(win, "Voltage? V = ");
			SW; V = num; num = 0;
			wprintw(win, "V = %f", V);
			wprintw(win, "\nCharge? q = ");
			SW; q = num; num = 0;
			wprintw(win, "q = %f", q);
			num = V*q;
			wprintw(win, "\nElectric field strenght = E = %f", num);
		} else if ( !strncmp(&sf, "q", sizeof(char)) ) {
			SOLVE_FOR;
			wprintw(win, "Voltage? V = ");
			SW; V = num; num = 0;
			wprintw(win, "V = %f", V);
			wprintw(win, "\nElectric field strenght? E = ");
			SW; E = num; num = 0;
			wprintw(win, "E = %f", E);
			num = E/V;
			wprintw(win, "\nCharge = q = %f", num);
		} else {
			NOPE;
		}
		Continue(win);
	} else if ( fshmek == '5' ) {
		werase(win); 
		wrefresh(win);
		waddstr(win, "\nV = E/q");
		waddstr(win, "\nSolve for (enter the letter)?: ");
		wscanw(win, "%s", &sf, buf);
		if ( !strncmp(&sf, "V", sizeof(char)) ) {
			SOLVE_FOR;
			wprintw(win, "Electric field strenght? E = ");
			SW; E = num; num = 0;
			wprintw(win, "E = %f", E);
			wprintw(win, "\nCharge? q = ");
			SW; q = num; num = 0;
			wprintw(win, "q = %f", q);
			num = E/q;
			wprintw(win, "\nVoltage = V = %f", num);
		} else if ( !strncmp(&sf, "E", sizeof(char)) ) {
			SOLVE_FOR;
			wprintw(win, "Voltage? V = ");
			SW; V = num; num = 0;
			wprintw(win, "V = %f", V);
			wprintw(win, "\nCharge? q = ");
			SW; q = num; num = 0;
			wprintw(win, "q = %f", q);
			num = V*q;
			wprintw(win, "\nElectric field strenght = E = %f", num);
		} else if ( !strncmp(&sf, "q", sizeof(char)) ) {
			SOLVE_FOR;
			wprintw(win, "Voltage? V = ");
			SW; V = num; num = 0;
			wprintw(win, "V = %f", V);
			wprintw(win, "\nElectric field strenght? E = ");
			SW; E = num; num = 0;
			wprintw(win, "E = %f", E);
			num = E/V;
			wprintw(win, "\nCharge = q = %f", num);
		} else {
			NOPE;
		}
		Continue(win);
	} else if ( fshmek == '6' ) {
		werase(win); 
		wrefresh(win);
		waddstr(win, "\nV = IR");
		waddstr(win, "\nSolve for (enter the letter)?: ");
		wscanw(win, "%s", &sf, buf);
		if ( !strncmp(&sf, "V", sizeof(char)) ) {
			SOLVE_FOR;
			wprintw(win, "Current? I = ");
			SW; I = num; num = 0;
			wprintw(win, "I = %f", I);
			wprintw(win, "\nResistance? R = ");
			SW; R = num; num = 0;
			wprintw(win, "R = %f", R);
			num = I*R;
			wprintw(win, "\nVoltage = V = %f", num);
		} else if ( !strncmp(&sf, "I", sizeof(char)) ) {
			SOLVE_FOR;
			wprintw(win, "Voltage? V = ");
			SW; V = num; num = 0;
			wprintw(win, "V = %f", V);
			wprintw(win, "\nResistance? R = ");
			SW; R = num; num = 0;
			wprintw(win, "R = %f", R);
			num = V/R;
			wprintw(win, "\nCurrent flow = I = %f", num);
		} else if ( !strncmp(&sf, "R", sizeof(char)) ) {
			SOLVE_FOR;
			wprintw(win, "Voltage? V = ");
			SW; V = num; num = 0;
			wprintw(win, "V = %f", V);
			wprintw(win, "\nCurrent flow? I = ");
			SW; I = num; num = 0;
			wprintw(win, "I = %f", I);
			num = V/I;
			wprintw(win, "\nResistance = R = %f", num);
		} else {
			NOPE;
		}
		Continue(win);
	} else if ( fshmek == '7' ) {
		werase(win); 
		wrefresh(win);
		waddstr(win, "\nP = IV");
		waddstr(win, "\nSolve for (enter the letter)?: ");
		wscanw(win, "%s", &sf, buf);
		if ( !strncmp(&sf, "P", sizeof(char)) ) {
			SOLVE_FOR;
			wprintw(win, "Voltage? V = ");
			SW; V = num; num = 0;
			wprintw(win, "V = %f", V);
			wprintw(win, "\nCurrent? I = ");
			SW; I = num; num = 0;
			wprintw(win, "I = %f", I);
			num = V*I;
			wprintw(win, "\nPower = P = %f", num);
		} else if ( !strncmp(&sf, "I", sizeof(char)) ) {
			SOLVE_FOR;
			wprintw(win, "Voltage? V = ");
			SW; V = num; num = 0;
			wprintw(win, "V = %f", V);
			wprintw(win, "\nPower? P = ");
			SW; P = num; num = 0;
			wprintw(win, "P = %f", P);
			num = P/V;
			wprintw(win, "\nCurrent = I = %f", num);
		} else if ( !strncmp(&sf, "V", sizeof(char)) ) {
			SOLVE_FOR;
			wprintw(win, "Power? P = ");
			SW; P = num; num = 0;
			wprintw(win, "P = %f", P);
			wprintw(win, "\nCurrent? I = ");
			SW; I = num; num = 0;
			wprintw(win, "I = %f", I);
			num = P/I;
			wprintw(win, "\nVoltage = V = %f", num);
		} else {
			NOPE;
		}
		Continue(win);
	} else if ( fshmek == '8' ) {
		werase(win); 
		wrefresh(win);
		waddstr(win, "\nI = q/t");
		waddstr(win, "\nSolve for (enter the letter)?: ");
		wscanw(win, "%s", &sf, buf);
		if ( !strncmp(&sf, "I", sizeof(char)) ) {
			SOLVE_FOR;
			wprintw(win, "Charge? q = ");
			SW; q = num; num = 0;
			wprintw(win, "q = %f", q);
			wprintw(win, "\nTime? t = ");
			SW; t = num; num = 0;
			wprintw(win, "t = %f", t);
			num = q/t;
			wprintw(win, "\nCurrent = I = %f", num);
		} else if ( !strncmp(&sf, "q", sizeof(char)) ) {
			SOLVE_FOR;
			wprintw(win, "Current? I = ");
			SW; I = num; num = 0;
			wprintw(win, "I = %f", I);
			wprintw(win, "\nTime? t = ");
			SW; t = num; num = 0;
			wprintw(win, "t = %f", t);
			num = I*t;
			wprintw(win, "\nCharge = q = %f", num);
		} else if ( !strncmp(&sf, "t", sizeof(char)) ) {
			SOLVE_FOR;
			wprintw(win, "Current? I = ");
			SW; I = num; num = 0;
			wprintw(win, "I = %f", I);
			wprintw(win, "\nCharge? q = ");
			SW; q = num; num = 0;
			wprintw(win, "q = %f", q);
			num = q/I;
			wprintw(win, "\nTime = t = %f", num);
		} else {
			NOPE;
		}
		Continue(win);
	} else if ( fshmek == '9' ) {
		werase(win); 
		wrefresh(win);
		waddstr(win, "\nR = R1 + R2 + R3");
		waddstr(win, "\nSolve for (enter the letter)?: ");
		wscanw(win, "%s", &sf, buf);
		if ( !strncmp(&sf, "R", sizeof(char)) ) {
			SOLVE_FOR;
			wprintw(win, "R1 = ");
			SW; R1 = num; num = 0; 
			wprintw(win, "R1 = %f", R1);
			wprintw(win, "\nR2 = ");
			SW; R2 = num; num = 0;
			wprintw(win, "R2 = %f", R2);
			wprintw(win, "\nR3 = ");
			SW; R3 = num; num = 0;
			wprintw(win, "\nR3 = %f", R3);
			num = R1 + R2 + R3;
			wprintw(win, "\nTotal resistance = R = %f", num);
		} else if ( !strncmp(&sf, "R1", sizeof(char)) || !strncmp(&sf, "R2", sizeof(char)) || !strncmp(&sf, "R3", sizeof(char)) ) {
			SOLVE_FOR;
			wprintw(win, "Total resistance? R = ");
			SW; R = num; num = 0;
			wprintw(win, "R = %f", R);
			wprintw(win, "\nR(1) = ");
			SW; R1 = num; num = 0;
			wprintw(win, "R1 = %f", R1);
			wprintw(win, "\nR(2) = ");
			SW; R2 = num; num = 0;
			wprintw(win, "\nR2 = %f", R2);
			num = R - R1 - R2;
			wprintw(win, "\nThe resistance of the unknown resistor is %f", num);
		} else {
			NOPE;
		}
		Continue(win);
	} else if ( fshmek == '0' ) {
		werase(win); 
		wrefresh(win);
		waddstr(win, "\nR = R1 + R2 + R3");
		waddstr(win, "\nSolve for (enter the letter)?: ");
		wscanw(win, "%s", &sf, buf);
		if ( !strncmp(&sf, "R", sizeof(char)) ) {
			SOLVE_FOR;
			wprintw(win, "R1 = "); SW; R1 = num; num = 0;
			wprintw(win, "R1 = %f", R1);
			wprintw(win, "\nR2 = "); SW; R2 = num; num = 0;
			wprintw(win, "R2 = %f", R2);
			wprintw(win, "\nR3 = "); SW; R3 = num; num = 0;
			wprintw(win, "R3 = %f", R3);
			if ( ! R3 ) {
				num = 1/(1/R1 + 1/R2);
			} else if ( ! R2 ) {
				num = 1/(1/R1 + 1/R3);
			} else if ( ! R1 ) {
				num = 1/(1/R2 + 1/R3);
			} else if ( ! R1 && ! R2 ) {
				wprintw(win, "\nDivide by zero.\n");
			} else {
			num = 1/(1/R1 + 1/R2 + 1/R3);
			}
			wprintw(win, "\nTotal resistance = R = %f", num);
		} else {
			NOPE;
			wprintw(win, "\n( Not yet. )");
		}
		Continue(win);
    	/* end of elif dilemma ... */
	} else {
		werase(win);
		wrefresh(win);
		wprintw(win, "\nDoesn't exist.");
		Continue(win);
	}
	} 

	dilemma = '0';
	fshmek = ' ';
}

void fe_shmek() { 
fshmek = '1'; }
void ek_shmek() {
fshmek = '2'; }
void ef_shmek() {
fshmek = '3'; }
void ep_shmek() {
fshmek = '4'; }
void ve_shmek() {
fshmek = '5'; }
void vi_shmek() {
fshmek = '6'; }
void piv_shmek() {
fshmek = '7'; }
void iqt_shmek() {
fshmek = '8'; }
void rsum_shmek() {
fshmek = '9'; }
void rinv_shmek() {
fshmek = '0'; }

void
pick_function_list_e(int old_choice, int new_choice) {
#define MAX_OPTIONS ((sizeof(flist_electricity)/sizeof(flist_electricity[0])))
	register size_t f;
	attrset(A_NORMAL);
	refresh();
	move(1, 1);
	clrtobot();
	standout();
	printw("Solve the Problem. Select a formula to use.\n\n");
	standend();
	printw("These formulas are available for use; enter the letter of the variable you want to solve for when asked. Carrying appropriate units is your responsibility!");
	for ( f = 0; f < MAX_OPTIONS; f++ ) {
		mvaddstr(6+f, 7, flist_electricity[f].text);
	}
	if (old_choice != (-1))
		mvaddstr(6+old_choice, 7, flist_electricity[old_choice].text);
	attrset(A_REVERSE);
	mvaddstr(6+new_shmek, 7, flist_electricity[new_shmek].text);
	attrset(A_NORMAL);
	mvaddstr(LINES-2, 1, "Use 'j' for down and 'k' for up, Enter to run.");
	refresh();
}

void function_list_e(WINDOW *win) {
	Lastkey = getch();
	switch(Lastkey)
	{
	case 10: case 13:
	case 'x': case 'X':
	case KEY_ENTER:
		erase();
		refresh();
		(*flist_electricity[new_shmek].function)(win);
		erase();
		pick_function_list_e(old_shmek, new_shmek);
		break;
	case 'k':
	case KEY_UP:
		new_shmek = (new_shmek == 0) ? new_shmek : new_shmek-1;
		pick_function_list_e(old_shmek, new_shmek);
		break;
	case 'j':
	case KEY_DOWN:
		new_shmek = (new_shmek == MAX_OPTIONS - 1) ? new_shmek : new_shmek + 1;
		flist:
		pick_function_list_e(old_shmek, new_shmek);
		break;
	case 'q': case 'Q':
		standend();
		endwin();
		exit(0);
		break;
	case 'c': case 'C':
		CALCULATOR;
		goto flist;
	default:
		break;
    }
}


/* EOF */
