/*	$Id: phyz.h,v 1.16 2001/04/26 03:23:19 pvalchev Exp $	*/

/*
 * Copyright (c) 1998-2001 Peter V. Valchev <pvalchev@gmx.net>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *    
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * 3. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission
 *    from the author.
 * 
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
 * THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
 * ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef _PHYZ_PHYZ_H
#define _PHYZ_PHYZ_H

#include "config.h"
#include "version.h"
#include <stdio.h>
#include <stdarg.h>
#include <stdlib.h>
#include <ctype.h>
#include <signal.h>
#include <string.h>
#include <termios.h>
#include <math.h>
#include <memory.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/ioctl.h>

/* Determine which curses we have (checked by the configure script */
#if defined(HAVE_CURSES)
#include <curses.h>
#elif defined(HAVE_NCURSES)
#include <ncurses.h>
#elif defined(HAVE_SLCURSES)
#include <slcurses.h>
#endif

#define error (void)move(1,0), (void)ctrloel(), (void) printw
			/* error message print function */

#ifndef FALSE
#define FALSE 0
#define TRUE 1
#endif /* FALSE */

/* character definitions */
#define ctl(c) ((c)&037)
#define ESC 033
#define DEL 0177
#define SOLVE_FOR mvwprintw(win, 4, 0, "Ok, I'm solving for %s.\n", &sf);
#define NOPE mvwprintw(win, 4, 0, "Nonexistent %s.", &sf);
#define SW wscanw(win, "%f", &num, buf);

#define DONE 0

extern void Continue ();
int key_switch (); 
int main_screen ();
int usage ();

#ifndef M_PI
#define M_PI			3.14159265358979323846
#endif /* M_PI */

static char const CALC[] = "bc -l";

#define CALCULATOR erase(); refresh(); endwin(); system(CALC);

#endif /* _PHYZ_PHYZ_H */
