/*	$Id: projectile.c,v 1.9 2001/04/26 03:23:19 pvalchev Exp $	*/

/*
 * Copyright (c) 1998-2001 Peter V. Valchev <pvalchev@gmx.net>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *    
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * 3. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission
 *    from the author.
 * 
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
 * THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
 * ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#define _PHYZ_PROJECTILE_C

#include "phyz.h"
#include "keys.h"
#include "choice.h"

#ifndef lint
static const char rcsid[] = "$Id: projectile.c,v 1.9 2001/04/26 03:23:19 pvalchev Exp $";
#endif /* lint */

void time_shmak ();
void vtg_shmak ();
void vt_shmak ();
void pick_function_list_p ();
void function_list_p ();

int old_shmak = -1;
int new_shmak = 0;

char fshmak;

/* XXX: Pi (0x1c) is displayed as  (0xf1) because
 * most of the terminals lack the ability to display
 * the actual greek letter. (vt100 && vt220 are on
 * the top of my head). Ideas here'd be appreciated.
 */

#define PI_CHAR 0x1c

CHOICE flist_projectile[] =
{
	{ "t = sqrt((2*d)/g) [only vertical falling bodies]", time_shmak },
	{ "d = Vt + (gt)/2 (vertical)", vtg_shmak },
	{ "d = Vt (horizontal, because a = 0)", vt_shmak }
};

extern void
projectile_motion (WINDOW *win) {
	char buf[80];
	float num;
	float t, d, V;
	float g = 9.81;		/* If someone knows something more accurate.. */
	char sf;
	pick_choice(old_choice, new_choice);
	while ( dilemma != '3' && dilemma != '4' ) {
		choice_switch();
	}
	win = newwin(LINES, 0, 0, 0);

	/* Theory */
    if ( dilemma == '3' ) {
	waddstr(win, "\t\nYA OLDE THROW OUT HORIZONTALLY PROBLEM\n
	An object is throwm horizontally at 20m/s from a roof top that is 122.625 m above the ground. How far horizontally from the base of the building will the object land?
Vertical distance controls the time that the object is in the air (no original vertical velocity). The time for the object = the time to fall straight down:
t (fall) = sqrt((2d)/g) =
         = sqrt((2*-122.625)/(-9.81m/s)) =
         = 5 s
Horizontal distance (no acceleration):
d = Vt + at/2, but a = 0 =>
d = 20 m/s * 5s = 100 m

=> 100 m horizontally from the base of the building.
	");
	Continue(win);
	werase(win);
	wrefresh(win);
	waddstr(win, "\t\nYA OLDE THROW AT AN ANGLE QUESTION\n
	An object is throwm at 20 m/s at an agle of 30 above the horizontal.
a) What is the maximum height the object attains?
b) What is the maximum horizontal distance (range) that the object attains?

step one: find the vertical and horizontal components of the object when it is thrown:
           vertical = opp = sin * hyp = sin(30) * 20 m/s = 
 ^                                     = 10 m/s
 |  /      horizontal = adj = cos * hyp = cos(30) * 20 m/s =
 |/_____                                 = 17.32 m/s

 	=> (continue)
   ");
	Continue(win);
	werase(win);
	wrefresh(win);
	wprintw(win, "
	(continued)

a) The time the object is moving upward as well as the total time in the air are controlled by the vertical component:
   t (up) = (V(0) - V)/g; V(0) = 0 at the top
          = (0 - 10 m/s)/(-9.81 m/s) =
          = 1.019 s
   total time in air = 2 * t (up) = 2 * 1.019 s = 2.038 s
   maximum height comes at t (up)
   d = Vt + gt/2 = 10 m/s * 1.019 s + (-9.81 m/s * 1.019 s * 1.019 s)/2 =
                  = +10.19 m - 5.093 m = 5.1 m ( up )

b) Horizontal    d = Vt + at/2,  but a = 0 horizontally
   => using the total time in air we found:
   d = Vt = 17.31 m/s * 2.038 s =
     = 35.3 horizontally down range.
	");
	Continue(win);
	} 

	/* Solver */
    if ( dilemma == '4' ) { 
	werase(win);
	wrefresh(win);
	*buf = 0;
	num = 0;
	/* XXX: new menu */
	pick_function_list_p(old_choice, new_choice);
	/* listen until : */
	while ( fshmak != '1' && fshmak != '2' && fshmak != '3' ) {
		function_list_p();
	}
	echo();
	if ( fshmak == '1' ) {
		werase(win);
		wrefresh(win);
		waddstr(win, "\nt = sqrt((2g)/d)");
		waddstr(win, "\nSolve for (enter the letter)?: ");
		wscanw(win, "%s", &sf, buf);
			if ( !strncmp(&sf, "t", sizeof(char)) ) {
				SOLVE_FOR;
				wprintw(win, "Distance? d = ");
				wscanw(win, "%f", &num, buf);
				d = num; num = 0;
				wprintw(win, "d = %f", d);
				num = sqrt((2*g)/d);
				wprintw(win, "\nTime = t = %f", num);
			} else if ( !strncmp(&sf, "d", sizeof(char)) ) {
				SOLVE_FOR;
				wprintw(win, "Time? t = ");
				wscanw(win, "%f", &num, buf);
				t = num; num = 0;
				wprintw(win, "t = %f", t);
				num = (t*t*g)/2;
				wprintw(win, "\nDistance = d = %f", num);
			} else {
				NOPE;
			}
		Continue(win);
	} else if ( fshmak == '2' ) {
		werase(win); 
		wrefresh(win);
		waddstr(win, "\nd = Vt + (gt)/2");
		waddstr(win, "\nSolve for (enter the letter)?: ");
		wscanw(win, "%s", &sf, buf);
		if ( !strncmp(&sf, "d", sizeof(char)) ) {
			SOLVE_FOR;
			wprintw(win, "Speed? V = ");
			wscanw(win, "%f", &num, buf);
			V = num; num = 0;
			wprintw(win, "V = %f", V);
			wprintw(win, "\nTime? t = ");
			wscanw(win, "%f", &num, buf);
			t = num; num = 0;
			wprintw(win, "t = %f", t);
			num = V*t + (g*t*t)/2;
			wprintw(win, "\nDistance = d = %f", num);
		} else if ( !strncmp(&sf, "V", sizeof(char)) || !strncmp(&sf, "v", sizeof(char))) 
		{
			SOLVE_FOR;
			wprintw(win, "Distance? d = ");
			wscanw(win, "%f", &num, buf);
			d = num; num = 0;
			wprintw(win, "d = %f", d);
			wprintw(win, "\nTime? t = ");
			wscanw(win, "%f", &num, buf);
			t = num; num = 0;
			wprintw(win, "t = %f", t);
			num = (d - (g*t*t)/2)/t;
			wprintw(win, "\nSpeed = V = %f", num);
		} else if ( !strncmp(&sf, "t", sizeof(char)) ) 
		{
			wprintw(win, "\n\nSorry, I can't solve for t.\nHopefully in the next release...");
		} else { 
			NOPE;
		} 
		Continue(win);
	} else if ( fshmak == '3' ) {
		werase(win); 
		wrefresh(win);
		waddstr(win, "\nd = Vt");
		waddstr(win, "\nSolve for (enter the letter)?: ");
		wscanw(win, "%s", &sf, buf);
		if ( !strncmp(&sf, "d", sizeof(char)) ) {
			SOLVE_FOR;
			wprintw(win, "Speed? V = ");
			wscanw(win, "%f", &num, buf);
			V = num; num = 0;
			wprintw(win, "V = %f", V);
			wprintw(win, "\nTime? t = ");
			wscanw(win, "%f", &num, buf);
			t = num; num = 0;
			wprintw(win, "t = %f", t);
			num = V*t;
			wprintw(win, "\nDistance = d = %f", num);
		} else if ( !strncmp(&sf, "V", sizeof(char)) || !strncmp(&sf, "v", sizeof(char)) ) {
			SOLVE_FOR;
			wprintw(win, "Distance? d = ");
			wscanw(win, "%f", &num, buf);
			d = num; num = 0;
			wprintw(win, "d = %f", d);
			wprintw(win, "\nTime? t = ");
			wscanw(win, "%f", &num, buf);
			t = num; num = 0;
			wprintw(win, "t = %f", t);
			num = d/t;
			wprintw(win, "\nSpeed = V = %f", num);
		} else if ( !strncmp(&sf, "t", sizeof(char)) ) {
			SOLVE_FOR;
			wprintw(win, "Distance? d = ");
			wscanw(win, "%f", &num, buf);
			d = num; num = 0;
			wprintw(win, "d = %f", d);
			wprintw(win, "\nSpeed? V = ");
			wscanw(win, "%f", &num, buf);
			V = num; num = 0;
			wprintw(win, "V = %f", V);
			num = d/V;
			wprintw(win, "\nTime = t = %f", num);
		} else {
			NOPE;
		}
		Continue(win);
    	/* end of elif dilemma ... */
	} else {
		werase(win);
		wrefresh(win);
		wprintw(win, "\nDoesn't exist.");
		Continue(win);
	}
	} 

	dilemma = '0';
	fshmak = '0';
}

void time_shmak()
{ 
	fshmak = '1';
}

void vtg_shmak()
{
	fshmak = '2';
}

void vt_shmak() 
{
	fshmak = '3';
}

void
pick_function_list_p(int old_choice, int new_choice) {
#define MAX_OPTIONS ((sizeof(flist_projectile)/sizeof(flist_projectile[0])))
	register size_t f;
	attrset(A_NORMAL);
	refresh();
	move(1, 1);
	clrtobot();
	standout();
	printw("Solve the Problem. Select a formula to use.\n\n");
	standend();
	printw("These formulas are available for use; enter the letter of the variable you want to solve for when asked. Carrying appropriate units is your responsibility!");
	for ( f = 0; f < MAX_OPTIONS; f++ ) {
		mvaddstr(6+f, 7, flist_projectile[f].text);
	}
	if (old_choice != (-1))
		mvaddstr(6+old_choice, 7, flist_projectile[old_choice].text);
	attrset(A_REVERSE);
	mvaddstr(6+new_shmak, 7, flist_projectile[new_shmak].text);
	attrset(A_NORMAL);
	mvaddstr(LINES-2, 1, "Use 'j' for down and 'k' for up, Enter to run.");
	refresh();
}

void function_list_p(WINDOW *win) {
	Lastkey = getch();
	switch(Lastkey)
	{
	case 10: case 13:
	case 'x': case 'X':
	case KEY_ENTER:
		erase();
		refresh();
		(*flist_projectile[new_shmak].function)(win);
		erase();
		pick_function_list_p(old_shmak, new_shmak);
		break;
	case 'k':
	case KEY_UP:
		new_shmak = (new_shmak == 0) ? new_shmak : new_shmak-1;
		pick_function_list_p(old_shmak, new_shmak);
		break;
	case 'j':
	case KEY_DOWN:
		new_shmak = (new_shmak == MAX_OPTIONS - 1) ? new_shmak : new_shmak + 1;
		flist:
		pick_function_list_p(old_shmak, new_shmak);
		break;
	case 'q': case 'Q':
		standend();
		endwin();
		exit(0);
		break;
	case 'c': case 'C':
		CALCULATOR;
		goto flist;
	default:
		break;
    }
}


/* EOF */
